global sse_invertir_internal
global sse_calcular_corte_fotoBinaria_internal
global sse_bordesSimples_internal
global sse_bordesSobel_internal
global sse_BlackAndWhite_internal
global sse_zoom_internal
global sse_fotoBinaria_internal
global sse_filtroGauseano_internal
global sse_bordesCanny_internal

global sse_zoomBillinear_internal
global sse_duplicarContraste_internal
global sse_colorBalance_internal
global sse_bokeh_internal
global sse_nearestRot_internal

extern malloc
extern memcpy
extern free
extern exit

section .text
shufmaskLoad:  DB 0x00, 0xFF, 0xFF, 0xFF,   0x01, 0xFF, 0xFF, 0xFF,   0x02, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF
ShufmaskSave:  DB 0x00, 0x04, 0x08, 0xFF,   0xFF, 0xFF, 0xFF, 0xFF,   0xFF, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF
fullShufmaskLoad:  DB 0x00, 0xFF, 0xFF, 0xFF,   0x01, 0xFF, 0xFF, 0xFF,   0x02, 0xFF, 0xFF, 0xFF,    0x03, 0xFF, 0xFF, 0xFF
fullShufmaskSave:  DB 0x00, 0x04, 0x08, 0x0C,   0xFF, 0xFF, 0xFF, 0xFF,   0xFF, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF
bordesCannyLoad:  DB 0x00, 0xFF, 0xFF, 0xFF,   0x03, 0xFF, 0xFF, 0xFF,   0x06, 0xFF, 0xFF, 0xFF,    0x09, 0xFF, 0xFF, 0xFF
SobelSave1:  DB 0x00, 0x01, 0x04, 0x05,   0xFF, 0xFF, 0xFF, 0xFF,   0xFF, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF
SobelSave2:  DB 0x08, 0x09, 0x0C, 0x0D,   0xFF, 0xFF, 0xFF, 0xFF,   0xFF, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF
mask255:  DB 0xFF, 0x00, 0xFF, 0x00,   0xFF, 0x00, 0xFF, 0x00,   0xFF, 0x00, 0xFF, 0x00,    0xFF, 0x00, 0xFF, 0x00
colorsMask: DB 0x00, 0x01, 0x04, 0x05,   0x08, 0x09, 0x00, 0x01,   0x04, 0x05, 0x08, 0x09,    0x00, 0x01, 0x04, 0x05
shufmaskLoadWords: DB 0x00, 0xFF, 0x01, 0xFF,   0x02, 0xFF, 0x03, 0xFF,   0x04, 0xFF, 0x05, 0xFF,    0x06, 0xFF, 0x07, 0xFF
shufmaskSaveWords: DB 0x00, 0x02, 0x04, 0x06,   0x08, 0x0A, 0x0C, 0x0E,   0xFF, 0xFF, 0xFF, 0xFF,    0xFF, 0xFF, 0xFF, 0xFF

;extern "C" void sse_bordesCanny_internal(unsigned char *Imagen, int h, int w, int ws, bool ByN, bool binario,
;                                        int *movx, int *movy, int *valorH, int *valorV, char *Emag, char *Egra);
sse_bordesCanny_internal:
		%define Imagen  dword [ebp + 8 + 4*0]
        %define h       dword [ebp + 8 + 4*1]
        %define w       dword [ebp + 8 + 4*2]
        %define ws      dword [ebp + 8 + 4*3]
        %define ByN     dword [ebp + 8 + 4*4]
        %define binario dword [ebp + 8 + 4*5]
        
        %define movx   dword [ebp + 8 + 4*6]
        %define movy   dword [ebp + 8 + 4*7]
        %define valorH dword [ebp + 8 + 4*8]
        %define valorV dword [ebp + 8 + 4*9]
        %define Emag   dword [ebp + 8 + 4*10]
        %define Egra   dword [ebp + 8 + 4*11]
        
        %define valH dword [ebp - 4]
        %define valV dword [ebp - 8]

        enter 8,0
        pusha
        movdqu xmm6, [SobelSave1]
		movdqu xmm4, [SobelSave2]
		movdqu xmm7, [bordesCannyLoad]
		mov eax, Emag
		mov ebx,65280
		mov  [eax], ebx
		mov  [eax+4], ebx
		mov  [eax+8], ebx
		mov  [eax+12], ebx
		movdqu xmm5, [eax]
		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 1
        dec h
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov ecx, Emag
			add ecx, eax
.cicloW:	 ;// no modificar ebx, edi
				
				pxor xmm2,xmm2 ; valH
				pxor xmm3,xmm3 ; valV
				xor esi,esi ;
				push ecx
			.cicloK:
					;//valH+= ([edi+movy[k]+ebx+movx[k]]) * valorH[k];					
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx					
					
					movd xmm1, [edi+ebx]
					PSHUFB xmm1, xmm7
					
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valorH
					mov ecx, [edx + esi*4]
					
					xor eax,eax
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					
					movd xmm0, eax
					PSHUFB xmm0, xmm7
					cmp ch, 0
					je .elsee2
						paddd xmm0,xmm5
					.elsee2:
					PMULLW xmm0, xmm1
					paddw xmm2, xmm0


					;//valV+= ([edi+movy[k]+ebx+movx[k]]) * valorV[k];
					
					mov edx, valorV
					mov ecx, [edx + esi*4]
					
					xor eax,eax
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					
					movd xmm0, eax
					PSHUFB xmm0, xmm7
					cmp ch, 0
					je .elsee3
						paddd xmm0,xmm5
					.elsee3:
					PMULLW xmm0, xmm1
					paddw xmm3, xmm0
					
					
					
					
					inc esi
					cmp esi, 9
					jne .cicloK

				pop ecx
				
				
				%macro rellenarEgra 1 ; eax = suma, %1 = valV, %2 = valH, %3 = bit

				;// if (sum > 255) sum = 0
				cmp ah, 0
				je %%sigue1
				mov al,0
%%sigue1:
				;// if (sum < 30) sum = 0
				mov  [ecx+ ebx + %1], al
				
				mov eax, valH
				mov edx, 1000
				imul edx
				mov valH, eax
				mov esi, edi
				sub esi, Imagen
				add esi, Egra
				add esi, ebx
				;//aux = 0;
				mov eax, 0
				mov [esi+ %1], al
				;//if (valH*1000 > valV*-425 && valH*1000 < valV * 425) aux = 4;
				mov eax, valV
				mov edx, -425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jg %%sigue2
					mov eax, valV
					mov edx, 425
					imul edx
					cmp eax, valH
					jl %%sigue2
						mov eax, 4
						mov [esi + %1], al
				%%sigue2:

				;//if (valH*1000 <valV*-425 && valH*1000 < valV *-2425)	aux = 8;
				mov eax, valV
				mov edx, -425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jl %%sigue3
					mov eax, valV
					mov edx, -2425
					imul edx
					cmp eax, valH
					jl %%sigue3
						mov eax, 7
						mov [esi+ %1], al
				%%sigue3:

				;//if (valH*1000 >valV*425 && valH*1000 < valV *2425)	aux = 7;
				mov eax, valH
				mov edx, 425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jg %%sigue4
					mov eax, valV
					mov edx, 2425
					imul edx
					cmp eax, valH
					jl %%sigue4
						mov eax,8 
						mov [esi+ %1], al
%%sigue4:
				%endmacro
				
				PABSw xmm0, xmm2 ; valH
				PABSw xmm1, xmm3 ; valV
				paddw xmm0, xmm1 ; xmm0 = suma
				
				movdqu xmm1, xmm0
				PSHUFB xmm1, xmm6
				movd eax, xmm1
				
				movdqu xmm1, xmm2
				PSHUFB xmm1, xmm6
				movd edx, xmm1
				
				movdqu xmm1, xmm3
				PSHUFB xmm1, xmm6				
				movd esi, xmm1
				
				shl eax, 16
				sar eax, 16
				shl edx, 16
				sar edx, 16
				shl esi, 16
				sar esi, 16
				
				mov valH, edx
				mov valV, esi
				rellenarEgra 0
				
				movdqu xmm1, xmm0
				PSHUFB xmm1, xmm6
				movd eax, xmm1
				
				movdqu xmm1, xmm2
				PSHUFB xmm1, xmm6
				movd edx, xmm1
				
				movdqu xmm1, xmm3
				PSHUFB xmm1, xmm6				
				movd esi, xmm1
				
				
				sar eax, 16
				sar edx, 16
				sar esi, 16				
				mov valH, edx
				mov valV, esi
				rellenarEgra 3
				
				;movdqu xmm1, xmm0
				;PSHUFB xmm1, xmm4
				;movd eax, xmm1
				
				;movdqu xmm1, xmm2
				;PSHUFB xmm1, xmm4
				;movd edx, xmm1
				
				;movdqu xmm1, xmm3
				;PSHUFB xmm1, xmm4				
				;movd esi, xmm1
				
				;shl eax, 16
				;sar eax, 16
				;shl edx, 16
				;sar edx, 16
				;shl esi, 16
				;sar esi, 16
				;mov valH, edx
				;mov valV, esi
				;rellenarEgra 6
				
				;movdqu xmm1, xmm0
				;PSHUFB xmm1, xmm4
				;movd eax, xmm1
				;
				;movdqu xmm1, xmm2
				;PSHUFB xmm1, xmm4
				;movd edx, xmm1
				;
				;movdqu xmm1, xmm3
				;PSHUFB xmm1, xmm4				
				;movd esi, xmm1
				;sar eax, 16
				;sar edx, 16
				;sar esi, 16
				;mov valH, edx
				;mov valV, esi
				;rellenarEgra 9

				add ebx,6
				cmp ebx, w
        		jl .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

		
		mov ecx, 1
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov esi, Emag
			add esi, eax
.cicloW2:	 ;// no modificar ebx, edi
				
				mov valH, 0
				mov valV, 0
				xor ecx,ecx ;
				mov [edi+ ebx], ecx ;//pone 4byte en 0 
				mov eax, esi
				sub eax, Emag
				add eax, Egra
				xor ecx, ecx
				mov cl, [eax + ebx] ;// ecx = k
				
				
				 
				;//if (Emag[esi+EBX] >= Emag[(esi + movy[k] +EBX+movx[k]] 
					mov edx, movx
					mov edx, [edx + ecx *4]
					add ebx,edx
					mov edx, movy
					mov edx, [edx + ecx *4]					
					add esi,edx

					xor eax,eax
					mov al, [esi+ ebx ]
					
					mov edx, movx
					mov edx, [edx + ecx*4]
					sub ebx, edx
					mov edx, movy
					mov edx, [edx + ecx *4]					
					sub esi, edx

					xor edx, edx
					mov dl, [esi+ ebx]
					cmp eax, edx
					jg .finif2

				;//&& Emag[esi+EBX] >= Emag[esi+movy[k]*-1+EBX+movx[k]*-1])
					mov edx, movx
					mov edx, [edx + ecx *4]
					sub esi,edx
					mov edx, movy
					mov edx, [edx + ecx *4]
					sub ebx,edx
					
					xor eax,eax
					mov al, [esi+ebx]
					
					mov edx, movx
					mov edx, [edx + ecx*4]
					add esi, edx
					mov edx, movy
					mov edx, [edx + ecx *4]
					add ebx, edx

					xor edx, edx
					mov dl, [esi+ ebx]
					cmp eax, edx
					jg .finif2

				mov al,[esi + ebx]									
				mov  [edi+ ebx], al
				mov  [edi+ ebx+1], al
				mov  [edi+ ebx+2], al
			.finif2:
				
				add ebx, 3
				cmp ebx, w
        		jne .cicloW2 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2 
    
    popa
    leave
    ret

;extern "C" void sse_calcular_corte_fotoBinaria_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                                int corteint, int *sumtecho, int *sumpiso, int *cantecho, int *canpiso);
sse_calcular_corte_fotoBinaria_internal:
    ; no se me ocurrio una optmizacion copada, igualmente usa sse en la otra parte del filtro    
        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        
        %define corteint    dword [ebp + 8 + 4*4]
        %define sumtechoPtr dword [ebp + 8 + 4*5]
        %define sumpisoPtr  dword [ebp + 8 + 4*6]
        %define cantechoPtr dword [ebp + 8 + 4*7]
        %define canpisoPtr  dword [ebp + 8 + 4*8]
        
        %define sumtecho dword [ebp - 4]
        %define sumpiso  dword [ebp - 8]
        %define cantecho dword [ebp - 12]
        %define canpiso  dword [ebp - 16]
       
    enter 16,0
    pusha
		movdqu xmm7, [BinariaLoad]
        mov eax, sumtechoPtr
        mov eax, [eax]
        mov sumtecho , eax
        
        mov eax, sumpisoPtr
        mov eax, [eax]
        mov sumpiso , eax
        
        mov eax, cantechoPtr
        mov eax, [eax]
        mov cantecho , eax
        
        mov eax, canpisoPtr
        mov eax, [eax]
        mov canpiso , eax
        
		xor esi,esi
        mov ecx, 0
        dec h
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				movdqu xmm0, [edi+ebx]
				PSHUFB xmm0, xmm7
				;movdqu xmm1, [edi+ebx +6]
				;PSHUFB xmm1, xmm7
				
				PHADDW xmm0, xmm1
				PHADDW xmm0, xmm1
				
				movd edx, xmm0
				
				
				xor eax, eax
				mov ax, dx
				
				cmp eax, corteint
				jl .elsee
					add cantecho, 1
					add sumtecho, eax;
					jmp .finif
				.elsee:
					add canpiso, 1
					add sumpiso, eax;
				
				.finif:
				shr edx, 16
				xor eax, eax
				mov ax, dx
				
				cmp eax, corteint
				jl .elsee2
					add cantecho, 1
					add sumtecho, eax;
					jmp .finif2
				.elsee2:
					add canpiso, 1
					add sumpiso, eax;
				
				.finif2:
				

				add ebx,6
				cmp ebx, w
        		jl .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

        mov eax, sumtecho
        mov ebx, sumtechoPtr
        mov [ebx], eax
        
        mov eax, sumpiso
        mov ebx, sumpisoPtr
        mov [ebx], eax
        
        mov eax, cantecho
        mov ebx, cantechoPtr
        mov [ebx], eax
        
        mov eax, canpiso
        mov ebx, canpisoPtr
        mov [ebx], eax
 
    popa
    leave
    ret


;extern "C" void sse_fotoBinaria_internal(unsigned char *Imagen, int h, int w, int ws, int corte);
BinariaLoad:  DB 0x00, 0xFF, 0x01, 0xFF,   0x02, 0xFF, 0xFF, 0xFF,   0x03, 0xFF, 0x04, 0xFF,    0x05, 0xFF, 0xFF, 0xFF
;BinariaSave:  DB 0x00, 0x00, 0x00, 0x04,   0x04, 0x04, 0x08, 0x08,   0x08, 0x0C, 0x0C, 0x0C,    0xFF, 0xFF, 0xFF, 0xFF

sse_fotoBinaria_internal:

        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        %define corte    dword [ebp + 8 + 4*4]
    
    enter 0,0
    pusha
    	;movdqu xmm6, [fullShufmaskSave]
		movdqu xmm7, [BinariaLoad]
    	mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				movdqu xmm0, [edi+ebx]
				PSHUFB xmm0, xmm7
				;movdqu xmm1, [edi+ebx +6]
				;PSHUFB xmm1, xmm7
				
				PHADDW xmm0, xmm1
				PHADDW xmm0, xmm1
				
				movd edx, xmm0
				
				xor eax,eax
				cmp dx, [ebp + 8 + 4*4] ; compara con corte
				jl .elsee
				mov eax, 0xFFFFFFFF
				.elsee:				
				mov [edi+ebx+0], eax
				
				shr edx, 16
				
				
				
				
				xor eax,eax
				cmp edx, [ebp + 8 + 4*4] ; compara con corte
				jl .elsee2
				mov eax, 255
				.elsee2:	

				mov [edi+ebx+3], al
				mov [edi+ebx+4], al
				mov [edi+ebx+5], al

				add ebx,6
				cmp ebx, w
        		jl .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret


;extern "C" void sse_filtroGauseano_internal(unsigned char *Imagen, int h, int w, int ws, bool ByN, int *movx, int *movy, int *valores);
sse_filtroGauseano_internal:
        
        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        %define ByN      dword [ebp + 8 + 4*4]
        %define movx     dword [ebp + 8 + 4*5]
        %define movy     dword [ebp + 8 + 4*6]
        %define valores  dword [ebp + 8 + 4*7]

        
        enter 0,0
        pusha
		movdqu xmm6, [fullShufmaskSave]
		movdqu xmm7, [fullShufmaskLoad]
		
		mov edi, Imagen
		mov dword [edi + 0], 273
		mov dword [edi + 4], 273
		mov dword [edi + 8], 273
		mov dword [edi + 12], 273
		movdqu xmm5, [edi]
		cvtdq2ps xmm5, xmm5
		
		mov eax, w
		sub eax,2
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 2
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,6
			push ecx
			
.cicloW:	 ;// no modificar ebx, edi
				
				xor ecx, ecx
				xor esi, esi ;
				PXOR xmm0, xmm0 
			.cicloK:
					;//sum+= I[y+movx[k]+i+movy[k])] )*valores[k];				
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx
					
					movd xmm1, [edi+ebx]
					PSHUFB xmm1, xmm7
							
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valores
					mov ecx, [edx + esi*4]
					mov eax, ecx
					mov edx, 256
					imul edx
					mov edx, 256
					add eax, ecx
					mov edx, 256
					imul edx
					mov edx, 256
					add eax, ecx
					imul edx
					add eax, ecx
					
					movd xmm2, eax
					PSHUFB xmm2, xmm7	
					
					PMULLW xmm2, xmm1				
					paddd xmm0, xmm2

					inc esi
					cmp esi, 25
					jne .cicloK

				
				cvtdq2ps xmm0, xmm0				
				DIVPS xmm0, xmm5
				cvtps2dq xmm0, xmm0
				
				PSHUFB xmm0, xmm6
				movd [edi+ebx], xmm0
					

				add ebx, 4
				cmp ebx, w
        		jl .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret


;extern "C" void sse_zoom_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                    int inih, int iniw, int finh, int finw,char *out);

sse_zoom_internal:

	%define Imagen   dword [ebp + 8 + 4*0]
	%define h        dword [ebp + 8 + 4*1]
	%define w        dword [ebp + 8 + 4*2]
	%define ws       dword [ebp + 8 + 4*3]
	%define inih     dword [ebp + 8 + 4*4]
	%define iniw     dword [ebp + 8 + 4*5]
	%define finh     dword [ebp + 8 + 4*6]
	%define finw     dword [ebp + 8 + 4*7]
	%define out      dword [ebp + 8 + 4*8]


	%define hh dword [ebp -4]
	%define ww dword [ebp -8]
    
    
    enter 8,0
    pusha
		
        mov hh, 0
        mov ww, 0
    
		xor esi,esi
        mov ecx, inih
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			
			mov ebx, iniw
			push ecx
			mov ecx, out
			mov eax, hh
			
			mov edx, ws
			mul edx			
			add ecx, eax
			mov ww, 0
.cicloW:
				mov eax, [edi + ebx]
				mov edx, ww
				mov [ecx + edx], eax
				mov [ecx + edx + 3], eax
				add edx, ws
				mov [ecx + edx], eax
				mov [ecx + edx + 3], eax
				
				mov eax, [edi + ebx+1]
				mov edx, ww
				mov [ecx + edx +1], eax
				mov [ecx + edx + 3+1], eax
				add edx, ws
				mov [ecx + edx+1], eax
				mov [ecx + edx + 3+1], eax

				
				mov eax, [edi + ebx+2]
				mov edx, ww
				mov [ecx + edx+2], eax
				mov [ecx + edx + 3+2], eax
				add edx, ws
				mov [ecx + edx+2], eax
				mov [ecx + edx + 3+2], eax
				
				add ww, 6;//cuidado!!!!!!!!!!!!
				add ebx, 3
				cmp ebx, finw
        		jne .cicloW 
            
			pop ecx
			add hh, 2
			inc ecx
            cmp ecx, finh
        	jne .cicloH 

       ;// pasar out a I
			
			mov ecx, 0
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			mov esi, out
			add esi, eax
			xor ebx,ebx 

.cicloW2:				
				movdqu xmm0, [esi + ebx]
				movdqu [edi + ebx], xmm0

				add ebx,16
				cmp ebx, w
        		jl .cicloW2 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2


    popa
    leave
    ret


;extern "C" void sse_bordesSobel_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                        int *movx, int *movy, int *valorH, int *valorV, char *out);


sse_bordesSobel_internal:

   
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    %define movx   dword [ebp + 8 + 4*4]
    %define movy   dword [ebp + 8 + 4*5]
    %define valorH dword [ebp + 8 + 4*6]
    %define valorV dword [ebp + 8 + 4*7]
    %define out    dword [ebp + 8 + 4*8]
    
    %define valH dword [ebp - 4]
    %define valV dword [ebp - 8]

    enter 8, 0
    pusha
		movdqu xmm6, [SobelSave1]
		movdqu xmm4, [SobelSave2]
		movdqu xmm7, [fullShufmaskLoad]
		mov eax, out
		mov ebx,65280
		mov  [eax], ebx
		mov  [eax+4], ebx
		mov  [eax+8], ebx
		mov  [eax+12], ebx
		movdqu xmm5, [eax]
		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 1
        dec h
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov ecx, out
			add ecx, eax
.cicloW:	 ;// no modificar ebx, edi
				push ecx
				mov valH, 0
				mov valV, 0
				pxor xmm2,xmm2 ; valH
				pxor xmm3,xmm3 ; valV
				xor esi,esi ;
			.cicloK:
					;//valH+= ([edi+movy[k]+ebx+movx[k]]) * valorH[k];					
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx					
					
					movd xmm1, [edi+ebx]
					PSHUFB xmm1, xmm7
					
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valorH
					mov ecx, [edx + esi*4]
					
					xor eax,eax
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					
					movd xmm0, eax
					PSHUFB xmm0, xmm7
					cmp ch, 0
					je .elsee2
						paddd xmm0,xmm5
					.elsee2:
					PMULLW xmm0, xmm1
					paddw xmm2, xmm0


					;//valV+= ([edi+movy[k]+ebx+movx[k]]) * valorV[k];
					
					mov edx, valorV
					mov ecx, [edx + esi*4]
					
					xor eax,eax
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					shl eax, 8
					mov al, cl
					
					movd xmm0, eax
					PSHUFB xmm0, xmm7
					cmp ch, 0
					je .elsee3
						paddd xmm0,xmm5
					.elsee3:
					PMULLW xmm0, xmm1
					paddw xmm3, xmm0
					
					
					
					
					inc esi
					cmp esi, 9
					jne .cicloK

				PABSw xmm2, xmm2
				PABSw xmm3, xmm3
				paddw xmm3, xmm2
				movdqu xmm2, xmm3
;				mov eax, edx
;				add eax, esi
;				cmp ah, 0
;				je .elsee
;				mov al,255
;.elsee:
				
				pop ecx
				PSHUFB xmm3, xmm6
				movd eax, xmm3
				cmp ah, 0
				je .finif1
					mov al,255
				.finif1:
				mov [ecx+ ebx], al
				
				shr eax, 16
				cmp ah, 0
				je .finif2
					mov al,255
				.finif2:
				mov [ecx+ ebx+1], al
				
				movdqu xmm3, xmm2
				PSHUFB xmm3, xmm4
				movd eax, xmm3
				cmp ah, 0
				je .finif3
					mov al,255
				.finif3:
				mov [ecx+ ebx+2], al
				
				shr eax, 16
				cmp ah, 0
				je .finif4
					mov al,255
				.finif4:
				mov [ecx+ ebx+3], al
				

				add ebx, 4
				cmp ebx, w
        		jl .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 
	;// pasar out a I
			
			mov ecx, 0
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			mov esi, out
			add esi, eax
			xor ebx,ebx 

.cicloW2:				
				movdqu xmm0, [esi + ebx]
				movdqu [edi + ebx], xmm0
				
				add ebx, 16
				cmp ebx, w
        		jl .cicloW2 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2
    
    popa
    leave
    ret

;extern "C" void sse_invertir_internal(unsigned char *Imagen, int h, int w, int ws);

sse_invertir_internal:

    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]

    enter 0,0
    
    pusha
		movdqu xmm2, [fullShufmaskLoad]
		movdqu xmm7, [fullShufmaskSave]
		
		mov edi, Imagen
		mov eax, -1
		mov byte [edi + 0], 255
		mov byte [edi + 1], 255
		mov byte [edi + 2], 255
		mov byte [edi + 3], 255
		mov byte [edi + 4], 255
		mov byte [edi + 5], 255
		mov byte [edi + 6], 255
		mov byte [edi + 7], 255
		mov byte [edi + 8], 255
		mov byte [edi + 9], 255
		mov byte [edi + 10], 255
		mov byte [edi + 11], 255
		mov byte [edi + 12], 255
		mov byte [edi + 13], 255
		mov byte [edi + 14], 255
		mov byte [edi + 15], 255
		MOVD  xmm3, [edi]
		PSHUFB xmm3, xmm2
		
		
		mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
        dec h
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				MOVD    xmm1, [edi + ebx]
				PSHUFB xmm1, xmm2
				MOVDQU xmm4, xmm3 ;xmm4 = 255,255,255,255
				PSUBB xmm4, xmm1
				PSHUFB xmm4, xmm7
				MOVD  [edi + ebx], xmm4
				
				 
				add ebx, 4
				cmp ebx, w
        		jl .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret

;extern "C" void sse_BlackAndWhite_internal(unsigned char *Imagen, int h, int w, int ws);
;extern "C" void sse_BlackAndWhite_internal(unsigned char *Imagen, int h, int w, int ws);
BlackAndWhiteLoad1:  DB 0x00, 0xFF, 0xFF, 0xFF,   0x03, 0xFF, 0xFF, 0xFF,   0x06, 0xFF, 0xFF, 0xFF,    0x09, 0xFF, 0xFF, 0xFF
BlackAndWhiteLoad2:  DB 0x01, 0xFF, 0xFF, 0xFF,   0x04, 0xFF, 0xFF, 0xFF,   0x07, 0xFF, 0xFF, 0xFF,    0x0A, 0xFF, 0xFF, 0xFF
BlackAndWhiteLoad3:  DB 0x02, 0xFF, 0xFF, 0xFF,   0x05, 0xFF, 0xFF, 0xFF,   0x08, 0xFF, 0xFF, 0xFF,    0x0B, 0xFF, 0xFF, 0xFF
BlackAndWhiteSave:  DB 0x00, 0x00, 0x00, 0x04,   0x04, 0x04, 0x08, 0x08,   0x08, 0x0C, 0x0C, 0x0C,    0xFF, 0xFF, 0xFF, 0xFF
sse_BlackAndWhite_internal:

    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    enter 0,0
    pusha
		movdqu xmm4, [BlackAndWhiteLoad1]
		movdqu xmm5, [BlackAndWhiteLoad2]
		movdqu xmm6, [BlackAndWhiteLoad3]
		movdqu xmm7, [fullShufmaskLoad]
		; preparar xmm2 con [30,59,11,0]
		mov edi, Imagen
		mov eax, 30
		mov [edi + 1 * 0], eax
		mov [edi + 1 * 1], eax
		mov [edi + 1 * 2], eax
		mov [edi + 1 * 3], eax
		MOVD xmm3, [edi]
		PSHUFB xmm3, xmm6
		
		mov eax, 59
		mov [edi + 4 + 1 * 0], eax
		mov [edi + 4 + 1 * 1], eax
		mov [edi + 4 + 1 * 2], eax
		mov [edi + 4 + 1 * 3], eax
		MOVD xmm3, [edi]
		PSHUFB xmm2, xmm5
		
		mov eax, 11
		mov [edi + 4 + 1 * 0], eax
		mov [edi + 1 * 1], eax
		mov [edi + 1 * 2], eax
		mov [edi + 1 * 3], eax
		MOVD xmm3, [edi]
		PSHUFB xmm1, xmm4
		 
		;mov eax, 0x42C80000
		;mov [edi + 4 * 0], eax
		;mov [edi + 4 * 1], eax
		;mov [edi + 4 * 2], eax
		;mov [edi + 4 * 3], eax
		;[fullShufmaskLoad]
		;MOVD xmm4, [edi]
		;PSHUFB xmm4, xmm7
		
		
		mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
        dec h
    .cicloH:
    		mov edi, Imagen
    		;mov eax, 0x42C80000
			;mov [edi + 4 * 0], eax
			;mov [edi + 4 * 1], eax
			;mov [edi + 4 * 2], eax
			;mov [edi + 4 * 3], eax
			mov eax, ws
			mul ecx
			add edi, eax		
			xor ebx, ebx
			mov eax, 505290270 ; 30, 30 ,30,30
			mov edx, 993737531 ; 59, 59 59 59
			mov esi, 185273099 ; 11 11 11 11
			movdqu xmm0, [edi + ebx]
.cicloW:
;eax+	Acumulador para operaciones aritmetico lógicas
;ebx-	Registro base para acceder a memoria
;ecx-	Contador para algunas instrucciones
;edx+	Registro de datos usado para algunas operaciones de entrada/salida
;edi-	Apuntador a destino para operaciones con cadenas de caracteres
;esi+	Apuntador a origen para operaciones con cadenas de caracteres

				;int sum  = 0;
				;sum += ((unsigned char)(*frame).imageData[y+i*3] ) * 30;
				;sum += ((unsigned char)(*frame).imageData[y+i*3+1])  * 59;
				;sum += ((unsigned char)(*frame).imageData[y+i*3+2])  * 11;
				;sum/=100;
				;(*frame).imageData[y+i*3] = (sum);
				;(*frame).imageData[y+i*3+1] = (sum);
				;(*frame).imageData[y+i*3+2] = (sum);
				
				movdqu xmm1, xmm0
				PSHUFB xmm1, xmm6
				movdqu xmm2, xmm0
				PSHUFB xmm2, xmm5
				movdqu xmm3, xmm0
				PSHUFB xmm3, xmm4
				
				MOVD   xmm0, eax
				PSHUFB xmm0, xmm7				
				PMULLW  xmm1, xmm0
                MOVD   xmm0, edx
				PSHUFB xmm0, xmm7				
				PMULLW  xmm2, xmm0
				MOVD   xmm0, esi
				PSHUFB xmm0, xmm7				
				PMULLW  xmm3, xmm0
				
				PADDD xmm1, xmm2
				PADDD xmm1, xmm3
				
				mov esi, 1684300900 ; 100 100 100 100
				MOVD   xmm0, esi
				PSHUFB xmm0, xmm7
				mov esi, 185273099 ; 11 11 11 11
				
				cvtdq2ps xmm1, xmm1
				cvtdq2ps xmm0, xmm0
				DIVPS xmm1, xmm0
				cvtps2dq xmm1, xmm1
				movdqu xmm2, [BlackAndWhiteSave]
				PSHUFB xmm1, xmm2
				movdqu xmm0, [edi + ebx + 12]
				movdqu [edi + ebx], xmm1
				
				
				

				add ebx, 12
				cmp ebx, w
        		jl .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 
            
    popa
    leave
    ret

;extern "C" void sse_bordesSimples_internal(unsigned char *Imagen, int h, int w, int ws);
bordesSimplesLoad:  DB 0x00, 0xFF, 0x01, 0xFF,   0x02, 0xFF, 0xFF, 0xFF,   0x03, 0xFF, 0x04, 0xFF,    0x05, 0xFF, 0xFF, 0xFF

sse_bordesSimples_internal:


    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]

    enter 0,0
    pusha
		movdqu xmm7, [bordesSimplesLoad]
		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			xor ebx, ebx
			push ecx
.cicloW:	 ;// no modificar ebx, edi
				xor esi, esi ;//esi = sum
				xor eax,eax
				xor edx,edx
				movdqu xmm0, [edi+ebx]
				PSHUFB xmm0, xmm7
				movdqu xmm1, [edi+ebx+3]
				PSHUFB xmm1, xmm7
				movdqu xmm1, [edi+ebx+3]
				PSHUFB xmm1, xmm7
				add edi, ws
				movdqu xmm2, [edi+ebx]
				PSHUFB xmm2, xmm7
				sub edi,ws
				psubw xmm1, xmm0
				pabsw xmm1, xmm1
				psubw xmm2, xmm0
				pabsw xmm2, xmm2
				
				paddw xmm1,xmm2
				
				PHADDW xmm1, xmm3
				PHADDW xmm1, xmm3
				
				movd eax, xmm1
				
				cmp ah, 0
				je .elsee
					mov al,255
				.elsee:
				mov  [edi + ebx], al
				mov  [edi + ebx+1], al
				mov  [edi + ebx+2], al
				shr eax, 16
				cmp ah, 0
				je .elsee2
					mov al,255
				.elsee2:
				mov  [edi + ebx+3], al
				mov  [edi + ebx+4], al
				mov  [edi + ebx+5], al

				add ebx, 6
				cmp ebx, w
        		jl .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret






; extern "C" void sse_zoomBillinear_internal(unsigned char *Imagen, int h, int w, int ws);

sse_zoomBillinear_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    %define auxBase     dword [ebp - 4 * 1]
    %define base        dword [ebp - 4 * 2]
    %define i           dword [ebp - 4 * 3]
    %define j           dword [ebp - 4 * 4]
    
    enter 4 * 4,0
    pusha

	; es el mismo filtro que zoom normal, hago llamada al otro metodos desde C++ 
	; si se implemente hay que cambiar el archivo funcionesSSE.cpp
    popa
    leave
    ret



; extern "C" void sse_duplicarContraste_internal(unsigned char *Imagen, int h, int w, int ws);
sse_duplicarContraste_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
        
    %define i      dword [ebp - 4*1]
    %define xm3    [ebp - 4*2]
    %define xm2    [ebp - 4*3]
    %define xm1    [ebp - 4*4]
    %define xm0    [ebp - 4*5]
    %define xm0dir  ebp - 4*5
    
    enter 4 * 5,0
    pusha

        ;int h = frame->height;
        ;int w = frame->width;
        ;const int WS = frame->widthStep;
        
        mov edi, Imagen ;uchar *base = (uchar*)frame->imageData;
        
        ;unsigned xm[3] = {0,0,0};
        ;xor eax, eax ;xm[0]
        ;xor ebx, ebx ;xm[1]
        ;xor ecx, ecx ;xm[2]
        pxor xmm0, xmm0
        movdqu xmm2, [shufmaskLoad]
        
        xor edx, edx
        ; LOOP 1
        mov esi, h
        mov i, esi
        ; for(int i= 0 ; i< h ; i++)
.loop1_I:
            mov esi, w
            lea esi, [esi + 2*esi]
            add esi, edi ; const uchar *pos = base;
            
        .loop1_J:
                sub esi, 3
                ;for(int j = 0 ; j < w ; j ++)
                ;{
                    
                    ;PMOVZXBD xmm1, [esi] REEMPLAZO ESTO QUE ES SSE4 CON MVDQU + PSHUFB
                    
                    MOVD   xmm1, [esi]
                    PSHUFB xmm1, xmm2
					PADDD xmm0, xmm1
					
                    
                    ; forn(col,3)
                    ;    xm[col] += *pos++;
                    ;mov dl, [esi]
                    ;add eax, edx
                    ;mov dl, [esi+1]
                    ;add ebx, edx
                    ;mov dl, [esi+2]
                    ;add ecx, edx
                ;}
                cmp esi, edi
                jne .loop1_J
            add edi, ws ;  base += WS;
            dec i
            jnz .loop1_I
        ; FIN DE LOOP 1
        
        MOVDQU xm0, xmm0
        mov eax, xm0
        mov ebx, xm1
        mov ecx, xm2
        
        mov edi, h
        imul edi, w
        
        xor edx, edx
        div edi
        xchg eax, ebx
        xor edx, edx
        div edi
        xchg eax, ebx
        xchg eax, ecx
        xor edx, edx
        div edi
        xchg eax, ecx
        ;forn(col,3)
        ;    xm[col] /= h*w;
        
        mov [xm0dir  ], al
        mov [xm0dir+1], bl
        mov [xm0dir+2], cl
        MOVD xmm0, xm0
        
        mov edi, Imagen   
            
        xor edx, edx
        ; LOOP 2
        mov esi, h
        mov i, esi
        ; for(int i= 0 ; i< h ; i++)
.loop2_I:
            mov eax, w
            lea eax, [eax + 2*eax]
            add eax, edi ; const uchar *pos = base;
            mov esi, edi
            
        .loop2_J:
                ;for(int j = 0 ; j < w ; j ++)
                ;{
                    
                    ;forn(col,3)
                    ;{
                    ;    int newCol = 2 * *pos - xm[col];
                    ;    if (newCol < 0) newCol = 0;
                    ;    if (newCol > 255) newCol = 255;
                    ;    *pos++ = newCol;
                    ;}
                    
                    ;%macro contrasteDoIt 2
                    ;    mov dl, [esi + %2]
                    ;    lea edx, [2 *edx]
                    ;    sub edx, %1
                    ;    jns %%sigue1
                    ;        xor edx, edx
                    ;        jmp %%sigue2
                    ;%%sigue1:
                    ;    test edx, 0xFFFFFF00
                    ;    jz %%sigue2
                    ;        mov edx, 255
                    ;%%sigue2:
                    ;    mov [esi + %2], dl
                    ;%endmacro
                    ;
                    ;contrasteDoIt eax,0
                    ;contrasteDoIt ebx,1
                    ;contrasteDoIt ecx,2
                    mov bl, [esi+3]
                    MOVD xmm1, [esi]
                    
                    MOVDQU xmm4, xmm0 ;xmm4 = xm
                    MOVDQU xmm3, xmm1 ;xmm3 = pos
                    PSUBUSB xmm4, xmm1 ; xmm4 = sat(x_m - pos) ; una de estas dos siempre es 0 y la otra es lo que debe ser
                    PSUBUSB xmm3, xmm0 ; xmm3 = sat(pos - x_m) ; una de estas dos siempre es 0 y la otra es lo que debe ser
                    
                    PADDUSB xmm1, xmm3 ; xmm1 = sat(pos + sat(pos - x_m))
                    PSUBUSB xmm1, xmm4 ; xmm1 = sat(sat(pos + sat(pos - x_m)) - sat(x_m - pos)) = sat(pos + sat(pos - x_m) - sat(x_m - pos))
                    
                    MOVD [esi], xmm1
                    mov [esi+3], bl
                    
                ;}
                add esi, 3
                cmp esi, eax
                jne .loop2_J
            add edi, ws ;  base += WS;
            dec i
            jnz .loop2_I
        ; FIN DE LOOP 1


    popa
    leave
    ret


; extern "C" void sse_colorBalance_internal(unsigned char *Imagen, int h, int w, int ws, unsigned RED, unsigned GREEN, unsigned BLUE);
sse_colorBalance_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    %define colorsdir     ebp + 8 + 4*4
    %define RED     dword [ebp + 8 + 4*4]
    %define GREEN   dword [ebp + 8 + 4*5]
    %define BLUE    dword [ebp + 8 + 4*6]
    
    %define i      dword [ebp - 4*1]
    
    enter 4 * 1,0
    pusha

		; int h = frame->height;
        ; int w = frame->width;
        ; const int WS = frame->widthStep;
        
        mov esi, Imagen ;uchar *base = (uchar*)frame->imageData;
        
        ; unsigned colorCoef[3] = {c1,c2,c3};
        ;mov ebx, RED
        ;mov ecx, GREEN
        mov edx, BLUE
        MOVDQU xmm0, [colorsdir]
        MOVDQU xmm4, [colorsMask]
        PSHUFB xmm0, xmm4
        MOVDQU xmm4, [shufmaskLoadWords]
        MOVDQU xmm3, [mask255]
        MOVDQU xmm6, [shufmaskSaveWords]
        
        xor eax, eax
        
        mov edi, h
        mov i, edi
        
        ;for(int i= 0 ; i< h ; i++)
        .loopI:
            mov ebx, w
            lea ebx, [ebx + 2*ebx]
            add ebx, esi ;uchar *pos = base;
            mov edi, esi
            
            ;for(int j = 0 ; j < w ; j ++)
            .loopJ:
                    ;forn(col,3)
                    ;{
                        ;%macro balanceDoIt 2
                        ;    ;int newCol = (colorCoef[col] * *pos ) / 128;
                        ;    ;if (newCol > 255) newCol = 255;
                        ;    ;*pos++ = newCol;
                        ;    mov al, [edi + %2]
                        ;    imul eax, %1
                        ;    shr eax, 7
                        ;    test eax, 0xFFFFFF00
                        ;    jz %%ok
                        ;        mov eax, 255
                        ;    %%ok:
                        ;    mov [edi + %2], al
                        ;%endmacro
                        
                        ;balanceDoIt ebx, 0
                        ;balanceDoIt ecx, 1
                        ;balanceDoIt edx, 2
                        
                        ; Procesamos 8 bytes, o sea 2 pixeles y 2 tercios
                        MOVQ   xmm1, [edi]
						PSHUFB xmm1, xmm4
						PMULLW xmm1, xmm0
						PSRLW xmm1, 7
						MOVDQU xmm2, xmm1
						PCMPGTW xmm2, xmm3
						POR xmm1, xmm2
						PSHUFB xmm1, xmm6
						MOVQ [edi], xmm1
						
						; Procesamos el ultimo byte del tercer pixel
                            mov al, [edi + 8]
                            imul eax, edx
                            shr eax, 7
                            test eax, 0xFFFFFF00
                            jz .okNoOverflow
                                mov eax, 255
                            .okNoOverflow:
                            mov [edi + 8], al
						
                    ;}
                add edi,9
                cmp edi, ebx
                jl .loopJ
            
            add esi, ws
            dec i
            jnz .loopI

		
    
    popa
    leave
    ret

;void bokeh(IplImage *frame, unsigned kernelSize)
;{
;	int h = frame->height;
;	int w = frame->width;
;    const int WS = frame->widthStep;
;    uchar *aux = (uchar*)malloc(WS*h);
;    memcpy(aux, frame->imageData, WS*h);
;    unsigned *k = (unsigned *)malloc(kernelSize * sizeof(unsigned));
;    unsigned AREA = 0;
;    forn(i,kernelSize)
;        AREA += 2 * (k[i] = sqrt(kernelSize * kernelSize - i*i)) - 1;
;    AREA = AREA * 2 - (2 * k[0] - 1);
;    
;    uchar *output = (uchar*)frame->imageData;
;    uchar *input = aux;
;    for(int i= 0 ; i< h ; i++)
;	{
;        unsigned total[3] = {0,0,0};
;        forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
;        {
;            forn(j,k[abs(ip)])
;            if (j < w)
;            forn(col,3)
;                total[col] += input[WS*ip + 3 * j + col];
;        }
;        
;        // En este punto ya estan computados los totales iniciales.
;        
;        uchar *inputPos = input;
;        uchar *outputPos = output;
;		for(int j = 0 ; j < w ; j ++)
;		{
;            forn(col,3)
;            {
;                *outputPos++ = total[col] / AREA;
;                // Quitar uno a izquierda, meter uno a derecha
;
;                forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
;                {
;                    const int D = k[abs(ip)];
;                    if (j-D+1 >= 0)
;                        total[col] -=  inputPos[WS*ip - 3*(D-1)];
;                    if (j+D < w)
;                        total[col] += inputPos[WS*ip + 3*D];
;                }
;                inputPos++;
;            }
;		}
;        output += WS;
;        input  += WS;
;	}
;    free(k);
;    free(aux);
;}

shiftpack:  DB 0x04, 0x05, 0x06, 0x07,   0x08, 0x09, 0x0A, 0x0B,   0x0B, 0x0C, 0x0D, 0x0F,    0xFF, 0xFF, 0xFF, 0xFF

; extern "C" void sse_bokeh_internal(unsigned char *Imagen, int h, int w, int ws, unsigned kernelSize, unsigned AREA, unsigned *kernel, unsigned char *aux);
sse_bokeh_internal:

    %define Imagen     dword [ebp + 8 + 4*0]
    %define h          dword [ebp + 8 + 4*1]
    %define w          dword [ebp + 8 + 4*2]
    %define ws         dword [ebp + 8 + 4*3]
    %define kernelSize dword [ebp + 8 + 4*4]
    %define AREA       dword [ebp + 8 + 4*5]
    %define kernel     dword [ebp + 8 + 4*6]
    %define aux        dword [ebp + 8 + 4*7]
    
    %define i         dword [ebp - 4*1]
    %define output    dword [ebp - 4*2]
    %define input     dword [ebp - 4*11]
    %define total2    dword [ebp - 4*4]
    %define total1    dword [ebp - 4*5]
    %define total0    dword [ebp - 4*6]
    %define tope      dword [ebp - 4*7]
    %define inputPos  dword [ebp - 4*8]
    %define outputPos dword [ebp - 4*9]
    %define saveEcx   dword [ebp - 4*10]
    
    %define totales   ebp - 4*6
    
    enter 4 * 11,0
    pusha
			movdqu xmm6, [shiftpack]
			movdqu xmm7, [shufmaskLoad]
            mov eax, Imagen
            mov output, eax  ; uchar *output = (uchar*)frame->imageData;
            
            mov eax, aux
            mov input, eax  ; uchar *input = aux;
            
            mov i, 0
            
            ;for(int i= 0 ; i< h ; i++)
            ;{
.startMainLoop:

                ;unsigned total[3] = {0,0,0};  = xmm0 
                pxor xmm0, xmm0
                mov total0, 0
                mov total1, 0
                mov total2, 0
                
                        ;forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
                        ;{
                            mov ebx, h
                            sub ebx, i
                            mov edx, kernelSize
                            cmp ebx, edx
                            cmovl edx, ebx ; edx = min(h-i, kernelSize)
                            mov tope, edx
                        
                            mov ecx, kernelSize
                            dec ecx
                            mov eax, i
                            cmp eax, ecx
                            cmovl ecx, eax
                            neg ecx ; ecx = -min(kernelSize - 1, i) = max(-kernelSize+1, -i)
                        .totalCalculationLoop:
                            
                            ; ecx = ip
                            
                            mov eax, ecx
                            neg eax
                            cmovs eax, ecx ;eax = abs(ip)
                            
                            mov ebx, kernel
                            mov eax, [ebx + 4*eax] ; eax = kernel[abs(ip)]
                            
                            mov esi, w
                            cmp esi, eax
                            cmovl eax, esi ; eax = min(w,kernel[abs(ip)])
                        
                            mov esi, input
                            mov edi, ws
                            imul edi, ecx
                            add esi, edi ; esi = input + WS * ip
                            
                            mov edx , total0
                            mov edi , total1
                            mov ebx , total2
                            
                            mov saveEcx, ecx
                            xor ecx, ecx
                            .miniColorLoop:
                                    
                                    ; eax = j+1
                                    
                                    ;    forn(j,k[abs(ip)])
                                    ;    if (j < w)
                                    ;    forn(col,3)
                                    ;        total[col] += input[WS*ip + 3 * j + col];
                                    movd xmm1, [esi]
                                    PSHUFB xmm1, xmm7
                                    paddd xmm0 , xmm1
                                    add esi, 3
                                    
                                    dec eax
                                    jnz .miniColorLoop
                            
                            mov ecx, saveEcx
                            
                           
                            
                            inc ecx
                            cmp ecx, tope
                            jne .totalCalculationLoop
                        
                        ;}
                ;movdqu [totales], xmm0
                
                
                ; En este punto ya estan computados los totales iniciales.
                
                            
                            ;uchar *inputPos = input; 
                            ;uchar *outputPos = output;
                            
                            mov eax, output
                            mov outputPos, eax

                            mov ebx, input
                            
                            xor edi, edi ; edi = j = 0
                            .primerParteFor:
                                mov esi, outputPos
                                
                                    xor edx, edx
                                    movdqu xmm1, xmm0
                                    movd eax, xmm1
									PSHUFB xmm1, xmm6                                    
                                    div AREA
                                    mov [esi], al
                                    
                                    xor edx, edx
                                    movd eax, xmm1
									PSHUFB xmm1, xmm6
                                    div AREA
                                    mov [esi+1], al
                                    
                                    xor edx, edx
                                    movd eax, xmm1
                                    div AREA
                                    mov [esi+2], al
                                    
                                    add outputPos, 3
                                    
                                    ; *outputPos++ = total[col] / AREA;
                                    
                                    ;// Quitar uno a izquierda, meter uno a derecha
                                    
                                    
                                    
                                    mov eax, kernelSize
                                    dec eax
                                    mov ecx, i
                                    cmp eax, ecx
                                    cmovl ecx, eax 
                                    test ecx, ecx ; ecx = min(kernelSize-1,i)
                                    jz .fueraPrimerForsn
                                    
                                        mov edx, kernel
                                        
                                        mov inputPos, ebx
                                        .primerForsn:
                                            
                                            ;forsn(ip, 1, min(kernelSize-1, i))
                                            ;{
                                                sub ebx, ws
                                                ;const int D = k[ip];
                                                mov eax, [edx + 4]
                                                add edx, 4 ; eax = D
                                                lea esi, [edi + eax]
                                                cmp esi, w
                                                jge .noSumar1
                                                    ;if (j+D < w)
                                                    ;    total[col] += inputPos[-WS*ip + 3*D];
                                                    lea esi, [eax + 2*eax]
                                                    movd xmm1, [ebx + esi]
                                                    PSHUFB xmm1, xmm7
													paddd xmm0 , xmm1
                                                    mov eax, [edx]
                                                .noSumar1:
                                                neg eax ; eax = -D
                                                lea esi, [edi + eax + 1]
                                                test esi, esi
                                                js .noRestar1
                                                    ;if (j-D+1 >= 0)
                                                    ;    total[col] -=  inputPos[-WS*ip - 3*(D-1)];
                                                    lea esi, [eax + 2*eax]
                                                    movd xmm1, [ebx + esi + 3]
                                                    PSHUFB xmm1, xmm7
													psubd xmm0 , xmm1
                                                .noRestar1:
                                            ;}
                                            dec ecx
                                            jnz .primerForsn
                                        mov ebx, inputPos
                                    .fueraPrimerForsn:
                                    
                                    
                                    
                                    
                                    
                                    mov eax, kernelSize
                                    mov ecx, h
                                    sub ecx, i
                                    cmp eax, ecx
                                    cmovl ecx, eax ; ecx = min(h-i, kernelSize)
                                     
                                        mov edx, kernel
                                        
                                        mov inputPos, ebx
                                        .segundoForsn:
                                            
                                            ; forsn(ip, 0, min(h-i,kernelSize))
                                            ;{
                                                ;const int D = k[ip];
                                                mov eax, [edx]
                                                add edx, 4 ; eax = D
                                                lea esi, [edi + eax]
                                                cmp esi, w
                                                jge .noSumar2
                                                    ;if (j+D < w)
                                                    ;    total[col] += inputPos[WS*ip + 3*D];
                                                    lea esi, [eax + 2*eax]
                                                    movd xmm1, [ebx + esi]
                                                    PSHUFB xmm1, xmm7
													paddd xmm0 , xmm1
                                                    mov eax, [edx - 4]
                                                .noSumar2:
                                                neg eax ; eax = -D
                                                lea esi, [edi + eax + 1]
                                                test esi, esi
                                                js .noRestar2
                                                    ;if (j-D+1 >= 0)
                                                    ;    total[col] -=  inputPos[WS*ip - 3*(D-1)];
                                                    lea esi, [eax + 2*eax]
                                                    movd xmm1, [ebx + esi + 3]
                                                    PSHUFB xmm1, xmm7
													psubd xmm0 , xmm1
                                                .noRestar2:
                                                add ebx, ws
                                            ;}
                                            dec ecx
                                            jnz .segundoForsn
                                        mov ebx, inputPos
                                    

                                ;    inputPos++;
                                ;}
                                add ebx, 3
                            inc edi
                            cmp edi, w; kernelSize
                            jne .primerParteFor
                            
                            mov eax, ws
                            add output, eax
                            add input , eax
                            ;output += WS;
                            ;input  += WS;

            
            mov eax, i
            inc eax
            mov i, eax
            cmp eax, h
            jne .startMainLoop
            ;}

    popa
    leave
    ret

;void nearestRot(IplImage *frame, float alpha)
;{
;    const float sinAlpha = sin(alpha);
;    const float cosAlpha = cos(alpha);
;	int h = frame->height;
;	int w = frame->width;
;    const int WS = frame->widthStep;
;    uchar *aux = (uchar*)malloc(WS*h);
;    memcpy(aux, frame->imageData, WS*h);    
;    uchar *output = (uchar*)frame->imageData;
;    const int cx = h/2, cy = w/2;
;    for(int i= 0 ; i< h ; i++)
;	{
;        uchar *outputPos = output;
;		for(int j = 0 ; j < w ; j ++)
;		{
;            const int ri = round(cx + cosAlpha * (i - cx) - sinAlpha * (j - cy) );
;            const int rj = round(cy + sinAlpha * (i - cx) + cosAlpha * (j - cy) );
;            if (0 <= ri && ri < h && 0 <= rj && rj < w)
;                forn(col,3) *outputPos++ = aux[WS*ri+3*rj+col];
;            else
;                forn(col,3) *outputPos++ = 0;
;		}
;        output += WS;
;	}
;    free(aux);
;}
; extern "C" void sse_nearestRot_internal(unsigned char *Imagen, int h, int w, int ws, unsigned char * aux, float sinAlpha, float cosAlpha);
sse_nearestRot_internal:


    %define Imagen   dword [ebp + 8 + 4*0]
    %define h        dword [ebp + 8 + 4*1]
    %define w        dword [ebp + 8 + 4*2]
    %define ws       dword [ebp + 8 + 4*3]
    %define aux      dword [ebp + 8 + 4*4]
    %define sinAlpha  [ebp + 8 + 4*5]
    %define cosAlpha  [ebp + 8 + 4*6]
    
    %define output   dword [ebp - 4*1]
    %define i        dword [ebp - 4*2]
    %define ri       ebp - 4*8
    %define rj       ebp - 4*12
    enter 4 * 12,0
    pusha
					mov eax, Imagen
					mov ebx, sinAlpha
					mov [eax], ebx
					mov [eax+4], ebx
					mov [eax+8], ebx
					mov [eax+12], ebx
					MOVDQU xmm0, [eax]
					mov eax, Imagen
					mov ebx, cosAlpha
					mov [eax], ebx
					mov [eax+4], ebx
					mov [eax+8], ebx
					mov [eax+12], ebx
					MOVDQU xmm1, [eax]
                    mov ebx, 1
                    mov [eax], ebx
					mov [eax+4], ebx
					mov [eax+8], ebx
					mov [eax+12], ebx
					MOVDQU xmm3, [eax]
					cvtdq2ps xmm3, xmm3
                    
                    ;uchar *output = Imagen;
                    mov eax, Imagen
                    mov output, eax
                    
                    
                    mov dword [eax], 0
					mov dword [eax+4], 1
					mov dword [eax+8], 2
					mov dword [eax+12], 3
					MOVDQU xmm7, [eax]
					
                    
                    
                    ;const int cx = h/2, cy = w/2;
                    
                    mov ecx, h
                    shr ecx, 1 ; ecx = cx
                    mov ebx, ecx
                    neg ebx
                    mov [eax], ebx
					mov [eax+4], ebx
					mov [eax+8], ebx
					mov [eax+12], ebx
					MOVDQU xmm2, [eax]
					paddd xmm2, xmm7
					cvtdq2ps xmm2, xmm2; xmm4 = -cx, -cx+1,-cx+2,-cx+3
                    mov ebx, w
                    shr ebx, 1 ; ebx = cy
                    neg ebx
                    mov [eax], ebx
					mov [eax+4], ebx
					mov [eax+8], ebx
					mov [eax+12], ebx
					MOVDQU xmm4, [eax]
					paddd xmm4, xmm7
					cvtdq2ps xmm4, xmm4; xmm4 = -cy, -cy+1,-cy+2,-cy+3
					MOVDQU xmm7, xmm4
					neg ebx 
					
                    ;mov eax, ecx
                    ;neg eax
                    ;cvtsi2ss xmm2, eax ; xmm2 = -cx     (i - cx)
                    
                    ;mov eax, 1
                    ;cvtsi2ss xmm3, eax ; xmm3 = 1 
                    
                    mov esi, h
                    mov i, esi
                    .iLoop:
                    ;for(int i= 0 ; i< h ; i++)
                    ;{
                        
                        ;mov eax, ebx
                        ;neg eax
                        ;cvtsi2ss xmm4, eax ; xmm2 = -cy     (j - cy)
                        mov eax, Imagen
                        mov ebx, w
						shr ebx, 1 ; ebx = cy
						neg ebx
						mov [eax], ebx
						inc ebx
						mov [eax+4], ebx
						inc ebx
						mov [eax+8], ebx
						inc ebx
						mov [eax+12], ebx
						MOVDQU xmm4, [eax]
						cvtdq2ps xmm4, xmm4; xmm4 = -cy, -cy+1,-cy+2,-cy+3
						neg ebx 
                        ;uchar *outputPos = output;
                        mov edx, output ; edx = outputPos
                        
                        mov edi, w
                        .jLoop:
                        ;for(int j = 0 ; j < w ; j ++)
                        ;{
                            
                            ;const int ri = round(cx + cosAlpha * (i - cx) - sinAlpha * (j - cy) );
                            MOVDQU xmm5, xmm2
                            MULPS  xmm5, xmm1
                            MOVDQU xmm6, xmm4
                            MULPS  xmm6, xmm0
                            subps xmm5, xmm6
                            
                            cvtps2dq xmm5, xmm5
                            MOVDQU [ri], xmm5
                            ;cvtss2si eax, xmm5 ; eax = ri
                            
                            
                           
                            
                            ;const int rj = round(cy + sinAlpha * (i - cx) + cosAlpha * (j - cy) );
                            MOVDQU xmm5, xmm2
                            mulps xmm5, xmm0
                            MOVDQU xmm6, xmm4
                            mulps xmm6, xmm1
                            addps xmm5, xmm6
                            
                            cvtps2dq xmm5, xmm5
                            MOVDQU [rj], xmm5
                            ;cvtss2si esi, xmm5 ; esi = rj
                            
                            %macro save 1
							;	mov dl, [esi + %2]
							;	lea edx, [2 *edx]
							;	sub edx, %1
							;	jns %%sigue1
							;		xor edx, edx
							;		jmp %%sigue2
							;%%sigue1:
							;	test edx, 0xFFFFFF00
							;	jz %%sigue2
							;		mov edx, 255
							;%%sigue2:
							;	mov [esi + %2], dl
							mov eax, [ri + %1 *4]
                            add eax, ecx
                            js %%finLoop
                            cmp eax, h
                            jge %%finLoop
                            mov esi, [rj + %1 *4]
                            add esi, ebx
                            
                            js %%finLoop
                            cmp esi, w
                            jge %%finLoop
                            
                                ; Copiamos el nearest neighbor
                                lea esi, [2*esi + esi]
                                imul eax, ws
                                add eax, aux
                                mov esi, [eax + esi]
                                mov dword [edx], esi
                                lea edx, [edx + 3]
                            
                            jmp %%finmacro
                            ;if (0 <= ri && ri < h && 0 <= rj && rj < w)
                            ;    forn(col,3) *outputPos++ = aux[ws*ri+3*rj+col];
                            ;else
                            ;    forn(col,3) *outputPos++ = 0;                            
                            %%finLoop:
                            
                                ; Mechamos un pixel negro
                                mov dword [edx], 0
                                lea edx, [edx + 3]
                            %%finmacro:
                            %endmacro
                            save 0
                            save 1
                            save 2                                                         
                            dec edi
                            jz .afuera
                            dec edi
                            jz .afuera
                            dec edi
                            jz .afuera
                            addps xmm4, xmm3
                            addps xmm4, xmm3
                            addps xmm4, xmm3
                            jmp .jLoop
                        ;}
                        .afuera:
                        
                        mov eax, ws
                        add output, eax
                        ;output += ws;
                        
                        addps xmm2, xmm3
                        
                        dec i
                        jnz .iLoop
                    ;}


    popa
    leave
    ret
