#include "filtrosCUDA.h"
#include "FuncionesCUDA.h"
#include "filtro.h"

void cu_invertir(IplImage * frame)
{
	cu_invertir((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void cu_bordesSimples(IplImage * frame)
{
	cu_bordesSimples((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void cu_bordesSobel(IplImage * frame)
{
	cu_bordesSobel((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void cu_BlackAndWhite(IplImage * frame)
{
	cu_BlackAndWhite((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void cu_zoom(IplImage * frame)
{
	cu_zoom((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void cu_fotoBinaria(IplImage * frame)
{
	cu_fotoBinaria((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void cu_filtroGauseano(IplImage * frame, bool ByN)
{
	cu_filtroGauseano((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, ByN);
}

void cu_bordesCanny(IplImage * frame, bool ByN, bool binario)
{
	cu_bordesCanny((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep,ByN,binario);
}


void cu_CambiarFrameAUnaSeccion(IplImage * frame, int h,int w,char* comienzo,int seccion)
{	
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,seccion);

}
void cu_todasJuntas(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;	
	char*comienzo = (*frame).imageData;
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,0);
	cu_BlackAndWhite(frame);
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,1);
	cu_invertir(frame);		
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,6);
	cu_bordesSimples(frame);
	cu_CambiarFrameAUnaSeccion(frame,h-1,w-1,comienzo,7);
	cu_bordesSobel(frame);
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,2);
	cu_fotoBinaria(frame);
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,3);
	cu_zoom(frame);
	cu_CambiarFrameAUnaSeccion(frame,h,w,comienzo,5);
	cu_filtroGauseano(frame, false);
	cu_CambiarFrameAUnaSeccion(frame,h-1,w-1,comienzo,8);
	cu_bordesCanny(frame, false,false);/**/



	(*frame).height = h;
	(*frame).width = w;
	(*frame).imageData = comienzo;

	return;
}


void cu_zoomBillinear(IplImage *frame)
{
	cu_zoomBillinear((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void cu_duplicarContraste(IplImage *frame)
{
	cu_duplicarContraste((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void cu_colorBalance(IplImage *frame, unsigned c1, unsigned c2, unsigned c3)
{
    cu_colorBalance((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, c1,c2,c3);
}

void cu_bokeh(IplImage *frame,unsigned kernelSize)
{
    cu_bokeh((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, kernelSize);
}

void cu_nearestRot(IplImage *frame,float alpha)
{
    cu_nearestRot((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, alpha);
}
